"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AcmgVariantClassification(ProtocolElement):
    """
    Full record for the ACMG variant clasiffication, including all
    selected evidences and the final classification.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "acmgEvidences",
        "clinicalSignificance",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "acmgEvidences": reports_6_6_0.AcmgEvidence,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "calculatedClinicalSignificance": reports_6_6_0.ClinicalSignificance,
            "clinicalSignificance": reports_6_6_0.ClinicalSignificance,
            "noAcmgEvidence": reports_6_6_0.AcmgEvidenceCategory,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "org.gel.models.report.avro.AcmgEvidence": reports_6_6_0.AcmgEvidence,
            "org.gel.models.report.avro.ClinicalSignificance": reports_6_6_0.ClinicalSignificance,
            "org.gel.models.report.avro.ClinicalSignificance": reports_6_6_0.ClinicalSignificance,
            "org.gel.models.report.avro.AcmgEvidenceCategory": reports_6_6_0.AcmgEvidenceCategory,
            "org.gel.models.report.avro.AcmgVariantClassification": reports_6_6_0.AcmgVariantClassification,
        }

    __slots__ = [
        "acmgEvidences",
        "clinicalSignificance",
        "assessment",
        "calculatedClinicalSignificance",
        "noAcmgEvidence",
    ]

    def __init__(
        self,
        acmgEvidences,
        clinicalSignificance,
        assessment=None,
        calculatedClinicalSignificance=None,
        noAcmgEvidence=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_6_0.AcmgVariantClassification model.

        :param acmgEvidences:
            Details of ACMG criteria used to score this variant
        :type acmgEvidences: list[AcmgEvidence]
        :param clinicalSignificance:
            Final classification selected by user
        :type clinicalSignificance: ClinicalSignificance
        :param assessment:
        :type assessment: None | str
        :param calculatedClinicalSignificance:
            Classification computed from ACMG scores
        :type calculatedClinicalSignificance: None | ClinicalSignificance
        :param noAcmgEvidence:
            ACMG evidence categories for which the user has indicated there is no
            evidence available
        :type noAcmgEvidence: None | list[AcmgEvidenceCategory]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.6.0"
